package com.persagy.dmp.rwd.edit.controller;

import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.json.JacksonMapper;
import com.persagy.common.web.ListResponse;
import com.persagy.dmp.rwd.edit.service.ClassDefService;
import com.persagy.dmp.rwd.model.ClassDefModel;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@Slf4j
@RestController
@RequestMapping("/rwdedit/def/class")
public class ClassDefController {
    @Autowired
    private ClassDefService service;

    @PostMapping("")
    public ListResponse<ClassDefModel> queryClass(@RequestBody JacksonCriteria criteria) {
        log.info("/class/query: {}", JacksonMapper.toSimpleJson(criteria));
        return service.queryClass(criteria);
    }

}
