package com.persagy.dmp.rwd.edit.entity;

import com.persagy.dmp.rwd.edit.model.RwdeditRefTypeModel;
import lombok.Getter;
import lombok.Setter;
import org.hibernate.annotations.CreationTimestamp;
import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.UpdateTimestamp;

import javax.persistence.*;
import java.util.Date;
import java.util.List;

@Setter
@Getter
@Entity
@Table(name = "rwdedit_ref_type")
public class RwdeditRefType {

    @Id
    @GeneratedValue(generator = "assignedId")
    @GenericGenerator(name = "assignedId", strategy = "assigned")
    private String refKey;
    private String name;
    @Column(updatable = false)
    private Integer createUser;
    @CreationTimestamp
    @Column(updatable = false)
    private Date createTime;
    private Integer updateUser;
    @UpdateTimestamp
    private Date updateTime;
    private Integer seq;
    private Integer showPosition;

    @OneToMany(cascade = CascadeType.ALL, orphanRemoval = true, mappedBy = "refKey")
    private List<RwdeditRefTypeInfos> infos;

    public static RwdeditRefType fromModel(RwdeditRefTypeModel model) {
        RwdeditRefType entity = new RwdeditRefType();
        entity.setRefKey(model.getRefKey());
        entity.setName(model.getName());
        entity.setCreateTime(model.getCreateTime());
        entity.setUpdateTime(model.getUpdateTime());
        entity.setCreateUser(model.getCreateUser());
        entity.setUpdateUser(model.getUpdateUser());
        entity.setSeq(model.getSeq());
        entity.setShowPosition(model.getShowPosition());
        entity.setInfos(model.getInfos());
        return entity;
    }

    public RwdeditRefTypeModel toModel() {
        RwdeditRefTypeModel model = new RwdeditRefTypeModel();
        model.setRefKey(this.getRefKey());
        model.setName(this.getName());
        model.setCreateTime(this.getCreateTime());
        model.setUpdateTime(this.getUpdateTime());
        model.setCreateUser(this.getCreateUser());
        model.setUpdateUser(this.getUpdateUser());
        model.setSeq(this.getSeq());
        model.setShowPosition(this.getShowPosition());
        return model;
    }
}
