package com.persagy.dmp.rwd.service;

import com.fasterxml.jackson.databind.node.ObjectNode;
import com.persagy.common.criteria.CriteriaUtils;
import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.rwd.entity.ClassDefWd;
import com.persagy.dmp.rwd.entity.QClassDefWd;
import com.persagy.dmp.rwd.enums.ObjType;
import com.persagy.dmp.rwd.model.ClassDefWdModel;
import com.persagy.dmp.rwd.repository.ClassDefWdRepository;
import com.persagy.dmp.rwd.util.ClassCodeUtils;
import com.querydsl.core.types.dsl.BooleanExpression;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.LinkedList;
import java.util.List;
import java.util.stream.Collectors;

@Slf4j
@Service
public class ClassDefWdService extends BaseService {

    @Autowired
    private ClassDefWdRepository classDefWdRepository;

    @Autowired
    private FuncidDefService funcidDefService;

    @Autowired
    private CriteriaUtils criteriaUtils;

    @Autowired
    private ClassCodeUtils classCodeUtils;

    private List<BooleanExpression> parse(ObjectNode object) {
        // TODO
        List<BooleanExpression> list = new LinkedList<>();
        QClassDefWd qt = QClassDefWd.classDefWd;
        list.addAll(CriteriaUtils.parse(qt.objType, object.get("objType"), ObjType.class));
        return list;
    }

    public PagedResponse<ClassDefWdModel> query(JacksonCriteria criteria) {
        PagedResponse<ClassDefWd> resp = criteriaUtils.query(QClassDefWd.classDefWd, this::parse, criteria);
        PagedResponse<ClassDefWdModel> result = new PagedResponse<>();
        result.setCount(resp.getCount());
        List<ClassDefWd> dataList = resp.getData();
        if (dataList != null && dataList.size() > 0) {
            List<ClassDefWdModel> collect = dataList.stream().map(entity -> {
                ClassDefWdModel model = entity.toModel();
                return model;
            }).collect(Collectors.toList());
            result.setData(collect);
        }
        return result;
    }

}

